<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryRef" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="主体名称" prop="subjectName" label-width="200">
        <el-input
            v-model="queryParams.subjectName"
            placeholder="请输入主体名称"
            clearable
            @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item label="统一社会信用代码" prop="unifiedSocialCreditCode" label-width="200">
        <el-input
            v-model="queryParams.unifiedSocialCreditCode"
            placeholder="请输入统一社会信用代码"
            clearable
            @keyup.enter="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
        <el-button icon="Refresh" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-popconfirm
            title="你确定清除所有数据？"
            confirm-button-text="是的"
            cancel-button-text="不是"
            :icon="InfoFilled"
            icon-color="#626AEF"
            @confirm="handleDelete"
        >
          <template #reference>
            <el-button
                type="danger"
                plain
                icon="Delete"
                v-hasPermi="['basicData:information:remove']"
            >清除全表
            </el-button>
          </template>
        </el-popconfirm>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="danger"
            plain
            icon="Delete"
            @click="batchDelete"
            v-hasPermi="['basicData:information:remove']"
            :disabled="ids.length === 0"
        >批量删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
            type="warning"
            plain
            icon="Download"
            @click="handleExport"
            :disabled="!informationList.length"
            v-hasPermi="['basicData:information:export']"
        >导出
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="info" plain icon="Upload" @click="handleImport"
                   v-hasPermi="['system:user:import']">导入
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button type="success" plain icon="Download" @click="downloadTemplate">
          下载导入模版
        </el-button>
      </el-col>
    </el-row>

    <el-table v-loading="loading" :data="informationList" height="650" @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="主体名称" align="center" prop="subjectName" :show-overflow-tooltip='true'/>
      <el-table-column label="统一社会信用代码" align="center" prop="unifiedSocialCreditCode" width="200"/>
      <el-table-column label="评价得分" align="center" prop="evaluationScore" :show-overflow-tooltip='true'/>
      <el-table-column label="评价等级" align="center" prop="evaluationGrade" :show-overflow-tooltip='true'/>
      <el-table-column label="数据来源" align="center" prop="dataSource" :show-overflow-tooltip='true'/>
    </el-table>

    <div style="position: fixed;bottom: 20px;right: 10px;">
      <pagination
          v-show="total>0"
          :total="total"
          v-model:page="queryParams.pageNum"
          v-model:limit="queryParams.pageSize"
          @pagination="getList"
      />
    </div>

    <el-dialog :title="upload.title" v-model="upload.open" width="400px" append-to-body>
      <el-upload ref="uploadRef" :limit="1" accept=".xlsx, .xls" :headers="upload.headers"
                 :action="upload.url + '?updateSupport=' + upload.updateSupport" :disabled="upload.isUploading"
                 :on-progress="handleFileUploadProgress" :on-success="handleFileSuccess" :auto-upload="false" drag>
        <el-icon class="el-icon--upload">
          <upload-filled/>
        </el-icon>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <template #tip>
          <div class="el-upload__tip text-center">
            <span>仅允许导入xls、xlsx格式文件。</span>
          </div>
        </template>
      </el-upload>
      <template #footer>
        <div class="dialog-footer">
          <el-button type="primary" @click="submitFileForm">确 定</el-button>
          <el-button @click="upload.open = false">取 消</el-button>
        </div>
      </template>
    </el-dialog>

    <!-- 添加或修改国家公共信用评价信息对话框 -->
  </div>
</template>

<script setup name="Information">
import {
  listInformation,
  getInformation,
  delInformation,
  delInformationBatch
} from "@/api/basicData/information26";
import {reactive, ref, toRaw} from "vue";
import {getToken} from "@/utils/auth";
import {ElMessage} from "element-plus";
import {likeQueryMethod} from "@/utils/likeQueryMethod";

const {proxy} = getCurrentInstance();

const informationList = ref([]);
const open = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const title = ref("");

const upload = reactive({
  // 是否显示弹出层（用户导入）
  open: false,
  // 弹出层标题（用户导入）
  title: '',
  // 是否禁用上传
  isUploading: false,
  // 设置上传的请求头部
  headers: {Authorization: getToken()},
  // 上传的地址
  url: import.meta.env.VITE_APP_BASE_API + '/crmNationalPublicCreditEvaluationInformation/importData'
})
const handleFileSuccess = (e) => {
  if (e.code == 200) {
    ElMessage({
      type: "success",
      message: e.msg
    })
    getList()
    proxy.$refs['uploadRef']?.clearFiles()
  } else {
    ElMessage({
      type: "error",
      message: e.msg
    })
    proxy.$refs['uploadRef']?.clearFiles()
  }
}

function submitFileForm() {
  proxy.$refs['uploadRef']?.submit();
  upload.open = false;
}

function handleImport() {
  upload.open = true
}

const data = reactive({
  form: {},
  queryParams: {
    pageNum: 1,
    pageSize: 20,
    subjectName: null,
    unifiedSocialCreditCode: '',
    evaluationScore: null,
    evaluationGrade: null,
    dataSource: null
  },
  rules: {
  }
});

const {queryParams, form, rules} = toRefs(data);

/** 查询国家公共信用评价信息列表 */
function getList() {
  loading.value = true;
  let toServerObj = likeQueryMethod('unified_social_credit_code', queryParams.value.unifiedSocialCreditCode, queryParams.value.pageNum, queryParams.value.pageSize);
  listInformation(toServerObj).then(response => {
    informationList.value = response.records;
    total.value = response.total;
    loading.value = false;
  });
}


// 表单重置
function reset() {
  form.value = {
    id: null,
    subjectName: null,
    unifiedSocialCreditCode: '',
    evaluationScore: null,
    evaluationGrade: null,
    dataSource: null
  };
  proxy.resetForm("informationRef");
}

/** 搜索按钮操作 */
function handleQuery() {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
function resetQuery() {
  proxy.resetForm("queryRef");
  handleQuery();
}

// 多选框选中数据
function handleSelectionChange(selection) {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}


/** 删除按钮操作 */
async function handleDelete(row) {
  const res = await delInformation();
  if(res.code == 200){
    ElMessage({
      type:'success',
      message:'删除成功'
    })
    getList();
  }
}
/** 批量删除*/
const batchDelete = (row)=>{
  const idsToS = row.id || ids.value;
  (proxy.$modal).confirm('是否确认删除这' + idsToS.length+'条的数据项？').then(function() {
    return delInformationBatch(toRaw(idsToS));
  }).then(() => {
    getList();
    proxy.$modal.msgSuccess("删除成功");
  }).catch(() => {});
}

/** 导出按钮操作 */
function handleExport() {
  proxy.download('crmNationalPublicCreditEvaluationInformation/exportData', {
    ...queryParams.value
  }, `国家公共信用评价信息_${new Date().getTime()}.xlsx`)
}
const downloadTemplate = ()=>{
  proxy.download('crmNationalPublicCreditEvaluationInformation/getUploadTemplate',{}, `国家公共信用评价信息模板.xlsx`)
}

getList();
</script>